<template>
    <div class="relative">
        <label :for="name" class="block mb-2 text-sm font-medium text-gray-900 ">{{ label }}</label>
        <textarea :name="name" :id="name" :value="inputValue" @input="handleChange" @blur="handleBlur" :rows="rows"
            class="block p-2.5 w-full text-sm text-gray-900 bg-gray-50 rounded-lg border border-gray-300 focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
            :placeholder="placeholder"></textarea>
        <p class="text-danger text-[13px] first-letter:uppercase" v-show="errorMessage || isInvalid">
            {{ errorMessage || errorMessageCustom }}
        </p>
    </div>

</template>

<script>
import { toRef } from "vue";
import { useField } from "vee-validate";

export default {
    name: "VTextArea",
    props: {
        value: {
            type: String,
            default: "",
        },
        name: {
            type: String,
            required: true,
        },
        label: {
            type: String,
            default: "",
        },
        errorMessageCustom: {
            type: String,
            default: "",
        },
        placeholder: {
            type: String,
            default: "",
        },
        isInvalid: {
            type: Boolean,
            default: false
        },
        rows: {
            type: Number,
            default: 4
        }
    },
    setup(props) {
        const name = toRef(props, "name");

        const {
            value: inputValue,
            errorMessage,
            handleBlur,
            handleChange,
            meta,
        } = useField(name, undefined, {
            initialValue: props.value,
        });

        return {
            handleChange,
            handleBlur,
            errorMessage,
            inputValue,
            meta,
        };
    },
}
</script>
